#include "..\Shared\string.h"
#include "..\Shared\iflag.h"

// Basic messages for BSOD
char *lineError = "Fatal Error:";

void BSOD(char *message)
{
	unsigned char *vidmem = (unsigned char *)0xB8000;
	int scrnOffset;
	int i;

	// Even before thinking of outputting to the screen, make sure we
	// CANNOT be interrupted ourselves, this could be VERY DISASTEROUS
	CLI();

	// First of all clear our screen
	for (i=0; i<80*25; i++)
	{
		vidmem[2*i] = '\0';
		vidmem[2*i+1] = 0x1F;
	}

	// Now skip some lines and print basic message
	scrnOffset = 80 * 11;
	scrnOffset += 40 - strlen(lineError) / 2;
	for (i=0; i<strlen(lineError); i++)
	{
		vidmem[2*scrnOffset] = lineError[i];
		scrnOffset++;
	}

	// Print the case specific error message
	scrnOffset = 80 * 12;
	scrnOffset += 40 - strlen(message) / 2;
	for (i=0; i<strlen(message); i++)
	{
		vidmem[2*scrnOffset] = message[i];
		scrnOffset++;
	}

	// go into an everlasting loop
	while (1) {}
}