#include "IDT.h"
#include "LIDT.h"

#include "..\BSOD System\BSOD.h"

struct IDTEntry IDTList[256];
struct IDTDesc IDTPtr;

void isrDummy();
unsigned long dummy = (unsigned)isrDummy;

void init_IDT()
{
	// just a loop counter
	int i;

	// Prepare IDTPtr structure
	IDTPtr.IDT = &IDTList[0];
	IDTPtr.length = sizeof(IDTList);

	// Prepare our IDT
	for (i=0; i<256; i++)
	{
		IDTList[i].offset_1 = dummy & 0x0000FFFF;
		IDTList[i].selector = 0x08;
		IDTList[i].zero = 0;
		IDTList[i].type_attr = 0x8E;
		IDTList[i].offset_2 = (dummy >> 16) &0x0000FFFF;
	}
}

void activate_IDT()
{
	LIDT(&IDTPtr);
}

void register_ISR(int INTCode, unsigned long isrAddr)
{
	// BSOD when INTCode out of range
	if (INTCode >= 256)
	{
	}

	// BSOD when INTCode already in use
	if ((IDTList[INTCode].type_attr | 0x80 == 0x80) && 
		!(IDTList[INTCode].offset_1 == dummy & 0x0000FFFF && 
		IDTList[INTCode].offset_2 == (dummy >> 16) & 0x0000FFFF))
	{
	}

	// Do the actual registering
	IDTList[INTCode].offset_1 = isrAddr & 0x0000FFFF;
	IDTList[INTCode].selector = 0x08;
	IDTList[INTCode].zero = 0;
	IDTList[INTCode].type_attr = 0x8E;
	IDTList[INTCode].offset_2 = (isrAddr >> 16) & 0x0000FFFF;
}